%global src_ver 3.5.5375

Name:           codelite
Version:        3.5.0.5375
Release:        1%{?dist}
License:        GPLv2+
Group:          Development/Tools
Summary:        Code editor for C/C++
URL:            http://codelite.sourceforge.net
Source0:        http://downloads.sourceforge.net/%{name}/%{name}-%{src_ver}-gtk.src.tar.gz
Patch0:         %{name}-3.5.0-wxsqlite.patch
Patch1:         %{name}-3.5.0-executable-plugins.patch
Patch2:         %{name}-2.9.0-no-debugger-on-crash.patch
Patch3:         %{name}-3.0.0-databaseexplorer-sqlite.patch
Patch4:         %{name}-3.5.0-sqlite-fully.patch
Patch5:         %{name}-3.5.0-clang.patch
Patch6:         %{name}-3.5.0-sqlite-timeout.patch
Patch10:        %{name}-3.5.5378.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires:       xterm
# the DB client libs are dlopen()-ed
Requires:       mysql-libs
Requires:       postgresql-libs
%if 0%{?fedora} || 0%{?rhel} >= 6
BuildRequires:  wxsqlite3-devel
%endif
BuildRequires:  wxGTK-devel
BuildRequires:  desktop-file-utils
BuildRequires:  sqlite-devel
BuildRequires:  mysql-devel
BuildRequires:  postgresql-devel
%if 0%{?fedora} >= 16
# clang >= 2.9 is required
BuildRequires:  clang-devel
%endif

%if 0%{?fedora} || 0%{?rhel} >= 6
%filter_provides_in -P %{_libdir}/%{name}/[^l].*\.so$
%filter_setup
%endif


%description
CodeLite is a powerful open-source, cross platform code editor for C/C++.
It uses a sophisticated, yet intuitive interface which allows users to
easily create, build and debug complex projects.


%prep
%setup -q -n %{name}-%{src_ver}
%if 0%{?fedora} || 0%{?rhel} >= 6
# use system sqlite3 library here
%patch0 -p1
%patch3 -p1
%patch4 -p1
# and remove unbundled code
rm -rf sqlite3 sdk/wxsqlite3 sdk/databaselayer/src/sqlite3
%endif
%patch1 -p1
%patch2 -p1
%patch5 -p1
%patch6 -p1
%patch10 -p1

# remove unbundled/unused code
rm -rf sdk/clang

# cleanup
#rm Runtime/templates/projects/dynamic-library-wx-enabled/dynamic-library-wx-enabled.project~


%build
./configure --prefix=%{_prefix} --plugins-dir=%{_libdir}/%{name} \
               --disable-debian --disable-desktop_icon --disable-make_symlink \
               --enable-mysql --enable-postgres \
%if 0%{?fedora} >= 16
    --enable-clang
%else
    %{nil}
%endif
make OPT="$RPM_OPT_FLAGS -DREGEX_UNICODE"


%install
rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install
desktop-file-install  --delete-original       \
%if ! 0%{?fedora} && 0%{?rhel} < 6
    --vendor=fedora \
%endif
     --dir $RPM_BUILD_ROOT%{_datadir}/applications            \
        $RPM_BUILD_ROOT%{_datadir}/applications/%{name}.desktop

# fix permissions
chmod 0644 $RPM_BUILD_ROOT%{_datadir}/%{name}/%{name}-icons.zip


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc AUTHORS LICENSE COPYING 
%{_bindir}/codelite
%{_bindir}/codelite_indexer
%{_bindir}/codelite_cppcheck
%{_bindir}/codelite_fix_files
%{_bindir}/codelite_exec
%{_bindir}/codelite_kill_children
%{_bindir}/codelite_xterm
%{_datadir}/%{name}
%{_datadir}/applications/*%{name}.desktop
%{_libdir}/%{name}


%changelog
* Sun Jan  1 2012 Dan Horák <dan[at]danny.cz> - 3.5.0.5375-1
- updated to 3.5.0.5375

* Tue Sep  6 2011 Dan Horák <dan[at]danny.cz> - 3.0.0.5041-1
- updated to 3.0.0.5041

* Sat Apr 23 2011 Dan Horák <dan[at]danny.cz> - 2.10.0.4778-2
- fix Provides filtering

* Thu Apr 14 2011 Dan Horák <dan[at]danny.cz> - 2.10.0.4778-1
- updated to 2.10.0.4778

* Fri Dec 31 2010 Dan Horák <dan[at]danny.cz> - 2.9.0.4684-1
- updated to 2.9.0.4537

* Tue Nov  2 2010 Dan Horák <dan[at]danny.cz> - 2.8.0.4537-1
- updated to 2.8.0.4537

* Thu Sep  2 2010 Dan Horák <dan[at]danny.cz> - 2.7.0.4375-3
- updated to 2.7.0.4375

* Thu Sep  2 2010 Dan Horák <dan[at]danny.cz> - 2.7.0.4368-2
- use internal wxsqlite3 on EL <= 5

* Wed Sep  1 2010 Dan Horák <dan[at]danny.cz> - 2.7.0.4368-1
- updated to 2.7.0.4368

* Fri Aug 20 2010 Dan Horák <dan[at]danny.cz> - 2.6.0.4189-3
- rebuilt for wxsqlite3-2.0.0.1

* Wed Jul 21 2010 Dan Horák <dan[at]danny.cz> - 2.6.0.4189-1
- updated to 2.6.0.4089

* Thu Jun 10 2010 Dan Horák <dan[at]danny.cz> - 2.5.3.4075-1
- updated to 2.5.3.4075

* Sun Apr 18 2010 Dan Horák <dan[at]danny.cz> - 2.5.2.4031-1
- initial version based on upstream
